#!/bin/sh
#Преобразует плейлисты .m3u в enigma2 userbouquet
#version 220214.1900
ping -q -c 1 -W 1 8.8.8.8 > /dev/null ; [ $? -eq 1 ] && { echo "Интернета нет . Проверте подключение к интернету ..." && exit; }
[ ! -x "`which curl`" ] && { echo "Нет утилиты curl . Выход" ; echo '' && exit; }
cd /tmp ; file="m3u_to_userbouquet" ; find -maxdepth 1 -mmin +10 -name ver.script -delete ; [ ! -s ver.script ] && curl --connect-timeout 15 -O "http://runigma.com.ua/upload/ver.script" > /dev/null 2>&1
if [ "`sed -n "s/\<$file\> //p" ver.script`" \> "`sed -n '3s/.*version //p' /usr/script/$file.sh`" ] ; then
    echo "upgrade script" ; sleep 1 ; echo '' ; curl --connect-timeout 15 -O "http://runigma.com.ua/upload/download_script/$file.tar.gz" > /dev/null 2>&1
    tar -xf $file.tar.gz -C / && EXIT='1'
fi
if [ ! -s /usr/script/reference ] || [ "`sed -n "s/reference //p" ver.script`" \> "`sed -n 's/.*version //p' /usr/script/reference`" ] ; then
    echo "update reference" ; sleep 1 ; tail -n +6 ver.script ; echo '' ; curl --connect-timeout 15 -O "http://runigma.com.ua/upload/reference.tar.gz" > /dev/null 2>&1
    tar -xf reference.tar.gz -C / && EXIT='1'
fi
[ "$EXIT" = "1" ] && { echo "Готово . Перезапустите скрипт" ; echo '' ; rm -rf *.tar.gz && exit; }
find -maxdepth 1 -type f -name "*.m3u*" -o -name "*.m3u8" | sed 's/^..//' > list
[ ! -s list ] && { echo "Нет ни одного файла .m3u .m3u8 в папке /tmp" ; echo '' && exit; }
while [ -s list ] ; do
    m3u=`cat list | head -n1`
    [[ "$m3u" = *" "* ]] && { sed -i "/${m3u}/s/ /_/g" list ; m3u=\"$m3u\" ; echo $m3u | sed 'p;s/ /_/g' | xargs -n2 mv ; m3u=`cat list | head -n1`; }
    name=`echo "$m3u" | sed 's/.m3u\|.m3u8//;s/_$//'`
    echo "userbouquet.$name.tv"
    sed -i "1d" list
    sed -i '/^http\|^#EXTINF\|^rtmp/!d' $m3u
    sed -i '/^#EXTINF/N;/\n#EXTINF/D' $m3u
    sed -i '/^http/N;/\nhttp/D' $m3u
    cat $m3u | awk 'NR%2==0 {print $0; print p} {p=$0}' >> file
    sed -i 's/^EXT/#EXT/g;/^#EXTINF/!s/:/%3a/g; s/,//2; s/[[:space:]]$\||User-Agent=.*//; s/^http\|^rtmp/#SERVICE 4097:0:1:0:0:0:0:0:0:0:&/' file
    if [ "$((`cat file | wc -l`/100*45))" -lt "`grep -c 'tvg-id' file`" ] ; then
        sed -i 's/.* tvg-id="//;s/".*,/,/' file ; sed -i "N;s/\n/*id=/" file ; sed -f /usr/script/reference_id -i file && sed -i 's/\*.*,/:/g; s/ \+/ /g' file # или sed -i 's/\*.*,/\n#DESCRIPTION /g; s/ \+/ /g' file
    else
        sed -i 'N;s/\n#EXTINF.*,/:/; s/ \+/ /g' file ; sed -f /usr/script/reference -i file
    fi
    echo "Референсы добавлены на каналы"
    sed -i "/iptv[12]*.evpanet\|udp\|mpegts/s/SERVICE 4097/SERVICE 1/g; 1s/^/#NAME $(echo "$name" | sed 's/_/ /g')\n/;" file
    mv file /etc/enigma2/userbouquet.$name.tv ; rm $m3u
    if grep -q "userbouquet.$name.tv" /etc/enigma2/bouquets.tv ; then
        echo 'Каналы перезаписаны' ; echo ''
    else
        echo 'Запись каналов в букеты' ; echo ''
        echo "#SERVICE 1:7:1:0:0:0:0:0:0:0:FROM BOUQUET \"userbouquet.$name.tv\" ORDER BY bouquet" >> /etc/enigma2/bouquets.tv
    fi
done
rm list ; echo 'Перезагрузка userbouquet' ; echo ''
wget -q -O - http://127.0.0.1/web/servicelistreload?mode=2 > /dev/null
exit 0
